/*******************************************************************************
+
+  LEDA 3.4
+
+  bool.h
+
+  This file is part of the LEDA research version (LEDA-R) that can be 
+  used free of charge in academic research and teaching. Any commercial
+  use of this software requires a license which is distributed by the
+  LEDA Software GmbH, Postfach 151101, 66041 Saarbruecken, FRG
+  (fax +49 681 31104).
+
+  Copyright (c) 1991-1996  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 66123 Saarbruecken, Germany     
+  All rights reserved.
+ 
*******************************************************************************/

#if !defined(__BUILTIN_BOOL__)

#if !defined(LEDA_ROOT_INCL_ID)
#define LEDA_ROOT_INCL_ID 340020
#include <LEDA/REDEFINE_NAMES.h>
#endif


/*{\Manpage {bool} {} {Boolean Values} }*/

/*{\Mdefinition
An instance of the data type $bool$ has either the value $true$ or $false$. 
The usual \CC logical operators \&\& (and), $||$ (or), ! (negation) are 
defined for $bool$. }*/


#if defined(_MSC_VER)

#define bool  char
#define false 0
#define true  1

#else

typedef char bool;
enum {false=0, true=1};

#endif



#if LEDA_ROOT_INCL_ID == 340020
#undef LEDA_ROOT_INCL_ID
#include <LEDA/UNDEFINE_NAMES.h>
#endif

#endif
