
// class for mutual exclusion using the CPS-library of the CONVEX

#include <cps.h>
#include <errno.h>

class mutex {

  mutex(const mutex& m) { cps_mutex_alloc(&lock_);} 

  mutex operator=(const mutex& m) { cps_mutex_alloc(&lock_); return *this; }

public:
  mutex() { cps_mutex_alloc (&lock_); }
 ~mutex() { cps_mutex_free (&lock_);  }


  void acquire() { cps_mutex_lock (&lock_); }
  void lock()    { cps_mutex_lock (&lock_); }
  void enter()   { cps_mutex_lock (&lock_); }

  void release() { cps_mutex_unlock (&lock_); }
  void unlock()  { cps_mutex_unlock (&lock_); }
  void exit()    { cps_mutex_unlock (&lock_); }

  int trylock()  { return cps_mutex_trylock (&lock_); }
  int tryenter() { return cps_mutex_trylock (&lock_); }
  

private:
  cps_mutex_t lock_;

}; 
