
// class for mutual exclusion using the solaris thread library 

#include <thread.h>
#include <errno.h>

class mutex {

  mutex(const mutex& m) { mutex_init(&lock_, 0, NULL); } 

  mutex operator=(const mutex& m) 
  { mutex_init (&lock_, 0, NULL); return *this; }

public:
  mutex() { mutex_init (&lock_, 0 , NULL); }
 ~mutex() { mutex_destroy (&lock_); }


  void acquire() { mutex_lock (&lock_); }
  void lock()    { mutex_lock (&lock_); }
  void enter()   { mutex_lock (&lock_); }

  void release() { mutex_unlock (&lock_); }
  void unlock()  { mutex_unlock (&lock_); }
  void exit()    { mutex_unlock (&lock_); }

  int trylock()  { return mutex_trylock (&lock_); }
  int tryenter() { return mutex_trylock (&lock_); }
  

private:
  mutex_t lock_;

}; 
