#include <LEDA/list.h>

class pair {

 double  x;
 double  y;

public:

pair(double a=0, double b=0) : x(a), y(b) {}

pair(const pair& p) : x(p.x), y(p.y) {}


friend istream& operator>>(istream& is, pair& p)
{ return is >> p.x >> p.y; }

friend ostream& operator<<(ostream& os, const pair& p)
{ return os << p.x << " " << p.y; }

friend int cmp(const pair& p, const pair& q);

};

template <class T>
inline int compare(const T& y, const T& x) { return cmp(x,y); }

main()
{ list<pair> L;
  L.read("list of pairs: ");
  L.sort();
  L.print("sorted:\n",'\n');
  return 0;
}


int cmp(const pair& p, const pair& q)
{  if (p.x < q.x) return -1; 
   if (p.x > q.x) return  1; 
   if (p.y < q.y) return -1; 
   if (p.y > q.y) return  1; 
   return 0;  
}
