
#include <LEDA/graph.h>
#include <LEDA/integer.h>
#include <LEDA/real.h>
#include <LEDA/vector.h>

struct Simple1 {
   string str;
};

inline void Print(const Simple1& x, ostream& out) { out << x.str; }
inline void Read(Simple1& x, istream& in) { in >> x.str; }


struct Simple2 {
   integer i;
};

inline void Print(const Simple2& x, ostream& out) { out << x.i; }
inline void Read(Simple2& x, istream& in) { in >> x.i; }

struct Simple3 {
   real r;

Simple3(int i) { r = i; }
Simple3() { r = 0; }
};

inline void Print(const Simple3& x, ostream& out) { out << x.r; }
inline void Read(Simple3& x, istream& in) { in >> x.r; }


#if !defined(__TEMPLATE_FUNCTIONS__)
inline int  compare(const Simple1&, const Simple1&) { return 0; }
inline int  compare(const Simple2&, const Simple2&) { return 0; }
inline int  compare(const Simple3&, const Simple3&) { return 0; }

LEDA_TYPE_PARAMETER(Simple1)
LEDA_TYPE_PARAMETER(Simple2)
LEDA_TYPE_PARAMETER(Simple3)
#endif



int main()
{
   GRAPH<Simple1,Simple2> G;

   test_graph(G);

   G.del_node(G.first_node());

   G.print();

   GRAPH<Simple1,Simple2> G1 = G;

   vector vec(1.1,2.2,3.3);
   node_array<Simple3> A(G1);
   edge_array<vector>  B(G1,vec);

   G1.print();

   int i = 0;
   node v;
   forall_nodes(v,G1) A[v] = i++;
   forall_nodes(v,G1) { Print(A[v],cout); cout << endl; }

 
   edge e;
   forall_edges(e,G1)  cout << B[e] << endl;

   return 0;
}

