#include <LEDA/graph.h>
#include <LEDA/face_array.h>
#include <LEDA/graph_alg.h>

void print_face(const GRAPH<int,int>& G, const face_array<int>& M, face f)
{ cout << string("F%d: ",M[f]);

  list<node> L1 = G.adj_nodes(f);

  node v;
  forall(v,L1) G.print_node(v);
  newline;
 }


main()

{  GRAPH<int,int> G;
   node v;
   edge e;
   face f;

   test_graph(G);

   Make_Bidirected(G);

   PLANAR(G,true);

   int count = 0;
   forall_nodes(v,G) G[v] = count++;
   count = 0;
   forall_edges(e,G) G[e] = count++;

   G.print();
   newline;

   G.make_map();
   G.compute_faces();

   face_array<int> M(G,0);

   count = 0;
   forall_faces(f,G) M[f] = count++;

   newline;
   forall_faces(f,G) print_face(G,M,f);

   newline;
   cout << "faces adjacent to nodes" << endl;

   forall_nodes(v,G)
   { G.print_node(v);
     cout << " : ";
     forall_adj_faces(f,v) cout << string("F%d ",M[f]);
     newline;
    }

 return 0;
}
