#include "ged.h"


void read_graph(window& W, GRAPH<point,int>& G,string s,bool clear)
{

  GRAPH<point,int> X;
  node v;
  node w;

  int x = X.read(s);

  if (x == 1) 
  { W.acknowledge(string("Cannot open file %s.",~s));
    return;
   }

  if (x == 2)
  { W.acknowledge("No coordinates found, I use a random embedding).");
    int max = int(W.xmax())-3;
    int min = 2;
    forall_nodes(v,X)
      X[v] = point(rand_int(min,max), rand_int(min,max));
   }

  if (clear) 
  { G.clear(); 
    W.clear(); 
   }

  node_array<node> corr(X);

  forall_nodes(v,X) 
  { node u = G.new_node(X[v]);
    corr[v] = u;
    draw_node(W,G,u);
   }

  edge e;
  forall_edges(e,X) 
  { v = corr[source(e)];
    w = corr[target(e)];
    G.new_edge(v,w);
    M(v,w)++;
   }

  if (clear) matrix_init(G);

  forall_nodes(v,G)
     forall_nodes(w,G) 
        draw_edge(W,G,v,w);

}



void save_graph(window& W, GRAPH<point,int>& G,string s)
{ if (s=="") 
     W.acknowledge("Cannot open file.");
  else
     G.write(s);
 }

