#include "ged.h"

edge find_edge(GRAPH<point,int>& G, point p)  
{ 
  edge   e_min = nil;
  double e_len = 0;
  double a_min = MAXDOUBLE;
  edge e;
  forall_edges(e,G)
  { point  s = G[source(e)];
    point  t = G[target(e)];

    double x0 = s.xcoord();
    double x1 = t.xcoord();

    if (x0 > x1)
    { x0 = t.xcoord();
      x1 = s.xcoord();
     }

    double y0 = s.ycoord();
    double y1 = t.ycoord();

    if (y0 > y1)
    { y0 = t.ycoord();
      y1 = s.ycoord();
     }

    if (p.xcoord() > x0 && p.xcoord() < x1 || 
        p.ycoord() > y0 && p.ycoord() < y1)
    { double a = fabs(area(s,t,p));
      if (a < a_min)
      { a_min = a;
        e_min = e;
        e_len = s.distance(t);
       }
     }
   }
  if ((a_min/e_len) < 0.25 * node_radius) return e_min;

  return nil;
 }

node nearest_node(GRAPH<point,int>& G, point p, double& d_min) 
{ node   v_min = nil;
  d_min = MAXINT;
  node v;
  forall_nodes(v,G)
  { double d =  p.distance(G[v]);
    if (d < d_min) 
    { v_min = v ;
      d_min = d;
     }
   }
  return v_min;
 }




node find_node(GRAPH<point,int>& G, point p) 
{ double d;
  node v = nearest_node(G,p,d);
  if (v && d > node_radius) v = nil;
  return v;
 }


