#include "ged.h"

void matrix_init(const graph& g)
{ edge e;
  int n = 100;
  if (2*g.number_of_nodes() > n) n = 2*g.number_of_nodes();
  M.init(g,n,0);
  forall_edges(e,g) M(source(e),target(e))++;
 }


void window_init(window& W)
{ W.set_redraw(redraw_func);
  W.set_node_width(node_width);
  W.init(x_min,x_max,y_min,0);
  node_radius = node_width/W.scale();
  W.set_mode(xor_mode);
  W.set_show_coordinates(true);
}


void dfs(graph& G, node v, node_array<bool>& reached, list<node>& L)
{ reached[v] = true;
  L.append(v);
  edge e;
  forall_inout_edges(e,v)
  { node u = G.opposite(v,e);
    if ( ! reached[u]) dfs(G,u,reached,L);
   }
}
