#include <LEDA/plane_alg.h>

random_source& operator>>(random_source& R, point& p)
{ double x,y;
  R >> x >>y;
  p = point(x,y);
  return R;
}


main()
{
   int N = read_int("N = ");

   list<point>     L;
   list<rat_point> L1;
   random_source ran(0,100000);

   ran.set_seed(12345*N);

   for(int i=0; i<N; i++) 
   { int x,y;
     ran >> x >> y;
     L.append(point(x,y));
     L1.append(rat_point(x,y));
    }


  // flipping with floating point points

  GRAPH<point,edge> G;

  cout << "DELAUNAY FLIP (float) " << flush;
  float T = used_time();
  TRIANGULATE_POINTS(L,G);
  float t1 = used_time(T);
  int f1 =DELAUNAY_FLIPPING(G);
  float t2 = used_time(T);
  cout << string("|V| = %d |E| = %d  %.2f sec (%.2f+%.2f) (%4d flips)",
             G.number_of_nodes(), G.number_of_edges()/2,t1+t2,t1,t2,f1) << endl;


  // flipping with rational points

  GRAPH<rat_point,edge> G1;

  cout << "DELAUNAY FLIP (exact) " << flush;
  T = used_time();
  TRIANGULATE_POINTS(L1,G1);
  t1 = used_time(T);
  f1 = DELAUNAY_FLIPPING(G1);
  t2 = used_time(T);
  cout << string("|V| = %d |E| = %d  %.2f sec (%.2f+%.2f) (%4d flips)",
          G1.number_of_nodes(), G1.number_of_edges()/2,t1+t2,t1,t2,f1) << endl;

/*
  rat_point::use_filter = false;
  cout << "DELAUNAY FLIP (nofilt)" << flush;
  T = used_time();
  TRIANGULATE_POINTS(L1,G1);
  t1 = used_time(T);
  f1 = DELAUNAY_FLIPPING(G1);
  t2 = used_time(T);
  cout << string("|V| = %d  |E| = %d  time = %.2f (%.2f + %.2f) (%4d flips)",
          G1.number_of_nodes(), G1.number_of_edges()/2,t1+t2,t1,t2,f1) << endl;
*/

 return 0;
}
