/*******************************************************************************
+
+  LEDA 3.4
+
+  _dfs.c
+
+  This file is part of the LEDA research version (LEDA-R) that can be 
+  used free of charge in academic research and teaching. Any commercial
+  use of this software requires a license which is distributed by the
+  LEDA Software GmbH, Postfach 151101, 66041 Saarbruecken, FRG
+  (fax +49 681 31104).
+
+  Copyright (c) 1991-1996  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 66123 Saarbruecken, Germany     
+  All rights reserved.
+ 
*******************************************************************************/
//------------------------------------------------------------------------------
// Depth First Search 
//------------------------------------------------------------------------------

#include <LEDA/graph_alg.h>

static void dfs(node s, node_array<bool>& reached, list<node>& L)
{
   L.append(s);
   reached[s] = true; 
   node v;
   forall_adj_nodes(v,s)
      if ( !reached[v] ) dfs(v,reached,L);
 }


list<node> DFS(const graph&, node v, node_array<bool>& reached)
{ 
  list<node>    L;
  dfs(v,reached,L);
  return L;
} 
