/*******************************************************************************
+
+  LEDA 3.4
+
+  local.h
+
+  This file is part of the LEDA research version (LEDA-R) that can be 
+  used free of charge in academic research and teaching. Any commercial
+  use of this software requires a license which is distributed by the
+  LEDA Software GmbH, Postfach 151101, 66041 Saarbruecken, FRG
+  (fax +49 681 31104).
+
+  Copyright (c) 1991-1996  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 66123 Saarbruecken, Germany     
+  All rights reserved.
+ 
*******************************************************************************/
#ifndef _GW_LOCAL_H_
#define _GW_LOCAL_H_

/****************************************************************************/
/*               Default values set at startup                              */
/****************************************************************************/
   
#define DefXMin		0
#define DefXMax		100
#define DefYMin		0

#define DefNodeColor	yellow
#define DefEdgeColor	black
#define DefHiNodeColor	blue
#define DefHiEdgeColor	blue
#define DefEdgeWidth	1
#define DefNodeType	circle_node
#define DefNodeStyle	filled_node
#define DefEdgeStyle	solid
#define DefNodeEmbed	random_embed
#define DefEdgeDist	0.75
#define DefFlush	true
#define DefDrawMode	xor_mode
#define DefDirected	false
#define DefGrid		0
#define DefShowCrd	false
#define DefZoomFactor	2
#define DefAnimation	10
#define DefNodeMove	move_all_nodes
#define DefNodeRadius	1
#define DefNodeRadius2	1
#define DefNodeWidth	14
#define DefNodeHeight	14
#define DefConstWidth	true
#define DefNodeLabelPos	central
#define DefEdgeLabelPos	right_below
#define DefGenNodes	16
#define DefGenEdges	30
#define DefEdgeLabel	""
#define DefNodeLabel	""
#define DefNodeLabelClr	black
#define DefEdgeLabelClr black
#define DefShowNodeLabel	false
#define DefShowEdgeLabel	false
#define DefNodeMarked	false
#define DefEdgeMarked	false
#define DefAutoEdge	true

#define DefButtonsPerLine 5

#define DefFileName	"graph"
#define DefFileExt	".lgr"
#define DefGWExt	".gw"
#define DefPSExt	".ps"

/****************************************************************************/
/*                                                                          */
/****************************************************************************/
   
#define NEW_BUTTON	MOUSE_BUTTON(1)
#define INFO_BUTTON	MOUSE_BUTTON(2)
#define DEL_BUTTON	MOUSE_BUTTON(3)

// GraphWin-created objects (window, graph, etc.)  

#define cr_none		(0l)
#define cr_stuff	(1l << 1)
#define cr_win		(1l << 2)
#define cr_graph	(1l << 3)

/****************************************************************************/
/*                                                                          */
/****************************************************************************/
   
enum { setup_global, setup_anim, setup_new, setup_gen };
enum { zoom_up, zoom_down, zoom_area, zoom_fill };
enum { node_type_reset, node_color_reset, node_style_reset, edge_color_reset,
       edge_style_reset, edge_width_reset, clear_graph_reset, nodes_reset, 
       edges_reset, both_reset, node_radii_reset };

#endif /* _GW_LOCAL_H_ */

