/*******************************************************************************
+
+  LEDA 3.4
+
+  gbase.h
+
+  This file is part of the LEDA research version (LEDA-R) that can be 
+  used free of charge in academic research and teaching. Any commercial
+  use of this software requires a license which is distributed by the
+  LEDA Software GmbH, Postfach 151101, 66041 Saarbruecken, FRG
+  (fax +49 681 31104).
+
+  Copyright (c) 1991-1996  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 66123 Saarbruecken, Germany     
+  All rights reserved.
+ 
*******************************************************************************/
void vga_init(int mode);

int  vga_width();
int  vga_height();
int  vga_depth();

void vga_clear(int col);  

void vga_setpal(int col, int red, int green, int blue);  
void vga_getpal(int col, int* red, int* green, int* blue);  
void vga_setmode(int mode);
void vga_setcolor(int col);

void vga_pixel(int x, int y);
void vga_hline(int x0, int x1, int y);
void vga_vline(int x, int y0, int y1);
void vga_bitmap(int left, int top, unsigned char* pm, int width, int height);

void vga_box(int x0, int y0, int x1, int y1);

char* vga_getimage(int left, int top, int right, int bottom);
void  vga_putimage(int x, int y,  char* image);
void  vga_delimage(char* image);
void  vga_copyimage(int left,int top,int right,int bottom,int x,int y);

// events

void dos_mouse_init(int disp_max_x, int disp_max_y);
void dos_mouse_exit();
int  dos_next_event(int* val, int* x, int* y, int block);
void dos_back_event();
void dos_draw_pointer(int x, int y);

