#include <LEDA/impl/x_window.h>
#include <stdio.h>
#include <vga.h>

#include "gbase.h"

// RGB values    wi bl  re  gr  bl  ye  vi  or  cy  br  pi  gr  bl  g1  g2  g3
int _R_[16] = {255, 0,255,  0,  0,224,160,255,  0,192,255,  0,128,212,184, 96};
int _G_[16] = {255, 0,  0,192,  0,224,  0,160,192,112,  0,160,128,212,184, 96};
int _B_[16] = {255, 0,  0,  0,255,  0,208,  0,192, 56,255,128,192,212,184, 96};


void vga_init(int mode)
{
  if (mode == 1) // graphics mode
  { if (!vga_setmode(G640x480x16))
     { fprintf (stderr, "Cannot switch to graphics mode 640x480x16\n");
       exit(1);
      }

     for(int i=0; i<16; i++) 
        vga_setpalette(i,_R_[i],_G_[i],_B_[i]);

    }
  else
    vga_setmode(TEXT);
}


void vga_clear(int col) {  }

int  vga_width()  { vga_getxdim();   }
int  vga_height() { vga_getydim();   }
int  vga_depth()  { vga_getcolors(); }

/*
void vga_setcolor(int col) { COLOR = col; }
*/


/*
void vga_setmode(int mode)
{ 
switch(mode) {
   case 0: g_wmode(G_NORM);
           break;
   case 1: g_wmode(G_AND);
           break;
   case 2: g_wmode(G_OR);
           break;
   case 3: g_wmode(G_XOR);
           break;
  }
}
*/


void vga_setpal(int index, int red, int green, int blue)
{ _R_[index] = red;
  _G_[index] = green;
  _B_[index] = blue;
  vga_setpalette(index,red,green,blue);
}

void vga_getpal(int index, int* red, int* green, int* blue)
{ *red   = _R_[index];
  *green = _G_[index];
  *blue  = _B_[index];
 }

void vga_pixel(int x, int y)              { vga_drawpixel(x,y); }
void vga_hline(int x0,int x1, int y)      { vga_drawline(x0,y,x1,y); }
void vga_vline(int x ,int y0, int y1)     { vga_drawline(x,y0,x,y1); }

void vga_box(int x0,int y0,int x1,int y1) 
{ while (y0  <= y1) vga_hline(x0,x1,y0++); }


static void vga_bytes(int x, int y, unsigned char* lp, int len)
{ unsigned char* stop = lp+len;
  while (lp < stop)
  { unsigned char c = *lp++;
    if (c & 128) vga_drawpixel(x,  y);
    if (c &  64) vga_drawpixel(x+1,y);
    if (c &  32) vga_drawpixel(x+2,y);
    if (c &  16) vga_drawpixel(x+3,y);
    if (c &   8) vga_drawpixel(x+4,y);
    if (c &   4) vga_drawpixel(x+5,y);
    if (c &   2) vga_drawpixel(x+6,y);
    if (c &   1) vga_drawpixel(x+7,y);
    x += 8;
   }
}

void vga_bitmap(int x, int y, unsigned char* pm, int width, int height)
{ while (height--)
  { vga_bytes(x,y++,pm,width);
    pm += width;
   }
 }


struct Image {
 int w;
 int h;
 char* buf;
};


char* vga_getimage(int left, int top, int right, int bottom )
{ Image* im = new Image;
  im->w = right - left + 1;
  im->h = bottom - top + 1;
/*
  int sz = g_imagesize(im->w,im->h);
  im->buf = new char[sz];
  g_getimage(left,top,right,bottom,im->buf);
*/
  return (char*)im;
}

void  vga_putimage(int x, int y, char* p)
{ Image* im = (Image*)p;
  //g_putimage(x,y,x+im->w-1,y+im->h-1,im->buf);
 }

void  vga_delimage(char* p) 
{ Image* im = (Image*)p;
  //delete[] im->buf; 
  delete im;
}


void vga_copyimage(int x1, int y1, int x2, int y2, int x, int y)
{ int w = x2 - x1 + 1;
  int h = y2 - y1 + 1;
/*
  int sz = g_imagesize(w,h);
  char* image = new char[sz];
  g_getimage(x1,y1,x2,y2,image);
  g_putimage(x,y,x+w-1,y+h-1,image);
  delete[] image;
*/
 }



