/*******************************************************************************
+
+  LEDA 3.4
+
+  _float_mulmuley.c
+
+  This file is part of the LEDA research version (LEDA-R) that can be 
+  used free of charge in academic research and teaching. Any commercial
+  use of this software requires a license which is distributed by the
+  LEDA Software GmbH, Postfach 151101, 66041 Saarbruecken, FRG
+  (fax +49 681 31104).
+
+  Copyright (c) 1991-1996  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 66123 Saarbruecken, Germany     
+  All rights reserved.
+ 
*******************************************************************************/
#define NO_RAT_ALGORITHMS
#include <LEDA/plane_alg.h>

inline void SMALLERY(const point& p, point& ymin)
{ if( ymin.ycoord() >= p.ycoord() )
      ymin = point( ymin.xcoord(), p.ycoord()-1.0);
}

inline point BOTTOM_FRAME_POINT( const point& p, const point& ymin)
{ return point(p.xcoord(), ymin.ycoord()); }


typedef point   POINT;
typedef segment SEGMENT;
 
#include "mulmuley.c"

