/*******************************************************************************
+
+  LEDA 3.4
+
+  _rat_balaban.c
+
+  This file is part of the LEDA research version (LEDA-R) that can be 
+  used free of charge in academic research and teaching. Any commercial
+  use of this software requires a license which is distributed by the
+  LEDA Software GmbH, Postfach 151101, 66041 Saarbruecken, FRG
+  (fax +49 681 31104).
+
+  Copyright (c) 1991-1996  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 66123 Saarbruecken, Germany     
+  All rights reserved.
+ 
*******************************************************************************/
#define NO_FLOAT_ALGORITHMS
#include <LEDA/plane_alg.h>


int cmp_at_x(const rat_segment& s1, const rat_segment& s2, 
	     const rat_point& x)
{   // Precondition : s1.start <= s1.end s2.start <= s2.end

  if(s1.is_vertical())
    if (s2.is_vertical()) return 0;
    else               return orientation(s2, x) >  0 ? 1 : -1;
  if(s2.is_vertical())    return orientation(s1, x) <= 0 ? 1 : -1;

  int c = cmp_segments_at_xcoord(s1, s2, x);
  if(c) return c;

  if( orientation( s1, x ) > 0 ) return cmp_slopes(s1, s2);

  return -cmp_slopes(s1, s2);
}


typedef rat_point   POINT;
typedef rat_segment SEGMENT;

#define STAIRCASE rat_stair_case

#include "balaban.c"
