/*******************************************************************************
+
+  LEDA 3.4
+
+  _rat_mulmuley.c
+
+  This file is part of the LEDA research version (LEDA-R) that can be 
+  used free of charge in academic research and teaching. Any commercial
+  use of this software requires a license which is distributed by the
+  LEDA Software GmbH, Postfach 151101, 66041 Saarbruecken, FRG
+  (fax +49 681 31104).
+
+  Copyright (c) 1991-1996  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 66123 Saarbruecken, Germany     
+  All rights reserved.
+ 
*******************************************************************************/
#define NO_FLOAT_ALGORITHMS
#include <LEDA/plane_alg.h>

void SMALLERY(const rat_point& p, rat_point& ymin)
{
  // Precondition : ymin.W() is 1

  if( ymin.Y() >= p.Y() )
     ymin = rat_point( ymin.X(), p.Y()-1 ); 
}

rat_point BOTTOM_FRAME_POINT( const rat_point& p, const rat_point& ymin)
{
  return rat_point(p.X(), ymin.Y()*p.W(), p.W());
}

typedef rat_point   POINT;
typedef rat_segment SEGMENT;

#include "mulmuley.c"

